//
//  AGInspectorRegistry.h
//  AGInspectorKit
//
//  Created by Seth Willits on 5/21/09.
//  Copyright 2009 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class AGInspector;


@interface AGInspectorRegistry : NSObject {
	NSMutableArray * mInspectors;
	NSMutableSet * mInspectionSet;
	
	// Window inspection state
	NSWindow * mLastWindowAskedToInspect;
	NSWindow * mLastMainWindowBeforeAppSwitch;
}

+ (AGInspectorRegistry *)sharedRegistry;
- (void)registerInspector:(AGInspector *)inspector;

+ (void)updateInspectors;
- (void)inspectionSetChanged;
- (NSSet *)inspectionSet;

- (BOOL)hasVisibleInspector;

@end
