//
//  AGNSSplitView.h
//  Queries
//
//  Created by Seth Willits on 8/20/08.
//  Copyright 2008 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


#if MAC_OS_X_VERSION_MAX_ALLOWED < MAC_OS_X_VERSION_10_5
enum {
   NSSplitViewDividerStyleThick = 1,
   NSSplitViewDividerStyleThin = 2,
};
typedef NSInteger NSSplitViewDividerStyle;
#endif


@interface AGNSSplitView : NSSplitView {
	BOOL mDrawsDivider;
	BOOL mOverridingThickness;
	CGFloat mDividerThickness;
	NSColor * mDividerColor;
	NSRectEdge mDividerLineEdge;
	BOOL mDrawsDividerHandle;
	NSSplitViewDividerStyle mDividerStyle;
}

- (void)setDividerThickness:(CGFloat)dividerThickness;

- (void)setDrawsDivider:(BOOL)draws;
- (BOOL)drawsDivider;

- (void)setDividerColor:(NSColor *)color;
- (NSColor *)dividerColor;

- (void)setDividerLineEdge:(NSRectEdge)edge;
- (NSRectEdge)dividerLineEdge;

- (void)setDrawsDividerHandle:(BOOL)drawsHandle;
- (BOOL)drawsDividerHandle;

- (void)setDividerStyle:(NSSplitViewDividerStyle)dividerStyle;
- (NSSplitViewDividerStyle)dividerStyle;

@end
