//
//  AGSection.h
//  AGSectionView
//
//  Created by Seth Willits on 12/29/06.
//  Copyright 2006 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class AGSectionView;
@class AGDisclosureButton;
@interface AGSection : NSView {
	NSView * _contentView;
	NSSize _contentSize;
	AGDisclosureButton * _disclosureTriangle;
	NSString * _title;
	BOOL _mouseIsDownInHeader;
}

// Creation
+ (id)sectionWithTitle:(NSString *)title contentView:(NSView *)contentView;
- (id)initWithTitle:(NSString *)title contentView:(NSView *)contentView;

// Accessors
- (AGSectionView *)sectionView;
- (NSString *)title;
- (void)setTitle:(NSString *)title;
- (NSSize)contentSize;
- (NSSize)currentSize;
- (BOOL)isExpanded;
- (NSView *)contentView;
- (void)setContentView:(NSView *)contentView;

// AGSectionView calls
- (void)setIsCollapsed:(BOOL)collapsed;
- (void)toggleSection:(id)sender;

@end
