//
//  AGShelfView.h
//  Araelium Edit 2.1
//
//  Created by Seth Willits on 8/02/06.
//  Copyright 2006 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AGShelfViewButton.h"
#import "AGShelfViewButtonView.h"


@interface AGShelfView : NSView
{
	IBOutlet NSView * shelfViewOutlet;
	IBOutlet NSView * contentViewOutlet;
	IBOutlet id delegateOutlet;
	
	NSView * mShelfView;
	NSView * mContentView;
	id mDelegate;
	AGShelfViewButtonView * mButtonView;
	
	NSString * autosaveName;
	NSColor * shelfBackgroundColor;
	CGFloat currentShelfWidth;
	BOOL isShelfVisible;
	
	NSRect controlRect;
	NSRect resizeThumbRect;
	NSRect resizeBarRect;
	int activeControlPart;
	int activeButtonIndex;
	BOOL shouldHilite;
	
	BOOL delegateValidatesWidth;
	BOOL useAlternates;
}

// Class Methods
+ (CGFloat)defaultShelfWidth;
+ (CGFloat)controlHeight;
+ (CGFloat)buttonWidth;
+ (CGFloat)thumbWidth;
+ (CGFloat)thumbLineSpacing;
+ (CGFloat)resizeBarEffectiveWidth;

// Initializer
- (id)initWithFrame:(NSRect)aFrame shelfView:(NSView *)aShelfView contentView:(NSView *)aContentView;

// Actions
- (IBAction)toggleShelf:(id)sender;

// Accessors
- (void)setShelfView:(NSView *)aView;
- (NSView *)shelfView;
- (void)setContentView:(NSView *)aView;
- (NSView *)contentView;
- (AGShelfViewButtonView *)buttonView;
- (void)setDelegate:(id)aDelegate;
- (id)delegate;
- (void)setShelfWidth:(CGFloat)aWidth;
- (CGFloat)shelfWidth;
- (BOOL)isShelfVisible;
- (void)setShelfIsVisible:(BOOL)visible;
- (void)setAutosaveName:(NSString *)aName;
- (NSString *)autosaveName;
- (void)setShelfBackgroundColor:(NSColor *)aColor;
- (NSColor *)shelfBackgroundColor;

// Drawing
+ (void)drawControlBackgroundInRect:(NSRect)aRect active:(BOOL)isActive;

@end


@interface NSObject (AGShelfViewDelegate)
- (NSMenu *)menuForButton:(AGShelfViewButton *)button inShelfView:(AGShelfView *)splitView;
- (CGFloat)shelfSplitView:(AGShelfView *)shelfSplitView validateWidth:(CGFloat)proposedWidth;
- (void)shelfSplitViewDidResize:(AGShelfView *)shelfSplitView;
@end







@interface AGShelfAuxiliaryView : NSView
{
}

@end
