//
//  AGTimeFormatter.h
//  Screencast
//
//  Created by Seth Willits on 4/27/10.
//  Copyright 2010 Araelium Group. All rights reserved.
//

#import <Cocoa/Cocoa.h>


typedef enum {
    AGTimeFormatterShortStyle = 0,	// 1d 2h 3m 4s
    AGTimeFormatterMediumStyle,		// 1 day 2hr 3min 4sec
    AGTimeFormatterLongStyle,		// 1 day, 2 hours, 3 minutes, 4 seconds
    AGTimeFormatterFullStyle,		// 
} AGTimeStyle;


@interface AGTimeFormatter : NSFormatter {
	AGTimeStyle mTimeStyle;
	BOOL mShowFractions;
}

- (AGTimeStyle)timeStyle;
- (void)setTimeStyle:(AGTimeStyle)style;

- (void)setShowFractions:(BOOL)show;
- (BOOL)showFractions;

@end
