//
//  AraeliumFoundationStructures.h
//  AraeliumFoundation
//
//  Created by Seth Willits on 5/21/09.
//  Copyright 2009 Araelium Group. All rights reserved.
//

#ifndef __AraeliumFoundationStructures_h
#define __AraeliumFoundationStructures_h


#define QGLOBAL	dispatch_get_global_queue(0, 0)
#define QMAIN	dispatch_get_main_queue()


#define AGForEachObject(type, var, enumerator)		NSEnumerator * var ## _enumerator = enumerator;		\
													type var = nil;										\
													while ((var = [var ## _enumerator nextObject]))


#define AGMakeError_Description_Suggestion(domain, errorCode, description, recoverySuggestion) \
			[NSError errorWithDomain:(domain) code:(errorCode) userInfo:[NSDictionary dictionaryWithObjectsAndKeys: \
				(description), NSLocalizedDescriptionKey, (recoverySuggestion), NSLocalizedRecoverySuggestionErrorKey, nil]]
				
				
#define AGMakeError_Description_Reason(domain, errorCode, description, reason) \
			[NSError errorWithDomain:(domain) code:(errorCode) userInfo:[NSDictionary dictionaryWithObjectsAndKeys: \
				(description), NSLocalizedDescriptionKey, (reason), NSLocalizedRecoverySuggestionErrorKey, nil]]

#define AGMakeError_Description_Reason_Suggestion(domain, errorCode, description, reason, recoverySuggestion) \
			[NSError errorWithDomain:(domain) code:(errorCode) userInfo:[NSDictionary dictionaryWithObjectsAndKeys: \
				(description), NSLocalizedDescriptionKey, (reason), NSLocalizedFailureReasonErrorKey, \
				(recoverySuggestion), NSLocalizedRecoverySuggestionErrorKey, nil]]



#ifndef __has_feature      // Optional.
#define __has_feature(x) 0 // Compatibility with non-clang compilers.
#endif


#ifndef NS_RETURNS_RETAINED
#if __has_feature(attribute_ns_returns_retained)
#define NS_RETURNS_RETAINED __attribute__((ns_returns_retained))
#else
#define NS_RETURNS_RETAINED
#endif
#endif


#ifndef CF_RETURNS_RETAINED
#if __has_feature(attribute_cf_returns_retained)
#define CF_RETURNS_RETAINED __attribute__((cf_returns_retained))
#else
#define CF_RETURNS_RETAINED
#endif
#endif



#endif
